shibsp::AttributeExtractor Class Referenceabstract

A service that extracts and decodes attributes from XML objects. More...

`#include <shibsp/attribute/resolver/AttributeExtractor.h>`

Inheritance diagram for shibsp::AttributeExtractor:
[legend]
Collaboration diagram for shibsp::AttributeExtractor:
[legend]

## Public Member Functions

virtual void | extractAttributes (const Application &application, const xmltooling::GenericRequest *request, const opensaml::saml2md::RoleDescriptor *issuer, const xmltooling::XMLObject &xmlObject, std::vector< Attribute * > &attributes) const =0
| Extracts the attributes found in an XMLObject.
virtual void | getAttributeIds (std::vector< std::string > &attributes) const =0
| Populates an array with the set of Attribute IDs that might be generated.
virtual void | generateMetadata (opensaml::saml2md::SPSSODescriptor &role) const
| Generates and/or modifies metadata reflecting the extractor, typically attribute-related requirements.

## Detailed Description

A service that extracts and decodes attributes from XML objects.

## Member Function Documentation

## extractAttributes()

virtual void shibsp::AttributeExtractor::extractAttributes | ( | const Application & | application,
|  | const xmltooling::GenericRequest * | request,
|  | const opensaml::saml2md::RoleDescriptor * | issuer,
|  | const xmltooling::XMLObject & | xmlObject,
|  | std::vector< Attribute * > & | attributes ) const

pure virtual

Extracts the attributes found in an XMLObject.

Parameters

  application | Application performing the extraction
  request | request triggering the extraction, if any
  issuer | source of object, if known
  xmlObject | object to extract
  attributes | an array to populate with the extracted attributes

Exceptions

  AttributeExtractionException | thrown if there is a problem extracting attributes

## generateMetadata()

virtual void shibsp::AttributeExtractor::generateMetadata | ( | opensaml::saml2md::SPSSODescriptor & | role | ) | const

virtual

Generates and/or modifies metadata reflecting the extractor, typically attribute-related requirements.

The default implementation does nothing.

Parameters

  role | metadata role to decorate

## getAttributeIds()

virtual void shibsp::AttributeExtractor::getAttributeIds | ( | std::vector< std::string > & | attributes | ) | const

pure virtual

Populates an array with the set of Attribute IDs that might be generated.

Parameters

  attributes | array to populate

The documentation for this class was generated from the following file:

- shibsp/attribute/resolver/AttributeExtractor.h